@use crate::templates::base;
@use crate::templates::labels;
@use crate::templates::downloads;
@use crate::templates::deps_list;
@use crate::date_now;
@use crate::iter::*;
@use crate::Urler;
@use crate::CratePage;
@use crate::Contributors;
@use rich_crate::Origin;
@use rich_crate::Edition;
@use std::ops::Div;
@use udedokei::LanguageExt;

@(url: &Urler, c: &CratePage)

@:base(&c.page(url), {
  <div typeof="SoftwareApplication">
  <header id="package" @if c.ver.is_yanked() {class="yanked"} else {@if c.ver.is_nightly() {class="nightly"}}>
    <div class="inner-col">
    <div class="breadcrumbs" typeof="BreadcrumbList">
    <h1>
      <span property="itemListElement" typeof="ListItem"><a property="item"
        typeof="WebPage" href="/"><span property="name">Lib</span>.rs</a><meta
        property="position" content="1"></span>
    </h1>
     ›
    @if c.ver.has_categories() {
      <span class="categories @if !c.ver.keywords().is_empty() {has-keywords}" role="navigaton" aria-label="Categories">
      @for (last, (major, cat)) in c.category_slugs_unique().iter().enumerate().identify_last() {
        @for (last, (i, subcat)) in cat.iter().enumerate().identify_last() {
          @if major < 2 {
            <span property="itemListElement" typeof="ListItem"><a href="@url.category(subcat)"
              title="@subcat.short_description" property="item" typeof="WebPage"><span
              property="name">@subcat.name</span></a><meta property="position" content="@(i+2)"></span>
          } else {
            <a href="@url.category(subcat)" title="@subcat.short_description">@subcat.name</a>
          }
          @if !last {›}
        }
        @if !last {|}
      }
      @if let Some(parent) = c.parent_crate() {
        › <span class="parent-crate"><a href="@url.krate(&parent)">@parent.capitalized_name()</a></span>
      }
      </span>
    }
    </div>
    @if let Some(keywords) = c.keywords_populated() {
      <span class="keywords">
        <span>
          @for (key, link) in keywords.iter().take(3) {
              <a property="applicationCategory" @if *link {href="@url.keyword(key)"} class=keyword><span>#</span>@key</a>
          }
        </span>
        @for (key, link) in keywords.iter().skip(3) {
          <a property="applicationCategory" @if *link {href="@url.keyword(key)"} class=keyword><span>#</span>@key</a>
        }
      </span>
    }
    <h2>
      @:labels(&c.ver, c.is_build_or_dev())

      <span property="name">
      @if c.ver.is_yanked() {
        <del>@c.ver.short_name()</del>
      } else {
        @if let Some((repo, package)) = c.ver.origin().repo() {
          @if let Some((_, url)) = c.ver.repository_http_url() {
            @if let Origin::GitHub{..} = c.ver.origin() {
              <a class="gh-logo" href="@url"><svg width="32" height="32" fill="currentColor" viewBox="0 0 16 16"><title>GitHub</title><path fill-rule="evenodd" d="M8 0C3.58 0 0 3.58 0 8c0 3.54 2.29 6.53 5.47 7.59.4.07.55-.17.55-.38 0-.19-.01-.82-.01-1.49-2.01.37-2.53-.49-2.69-.94-.09-.23-.48-.94-.82-1.13-.28-.15-.68-.52-.01-.53.63-.01 1.08.58 1.23.82.72 1.21 1.87.87 2.33.66.07-.52.28-.87.51-1.07-1.78-.2-3.64-.89-3.64-3.95 0-.87.31-1.59.82-2.15-.08-.2-.36-1.02.08-2.12 0 0 .67-.21 2.2.82.64-.18 1.32-.27 2-.27.68 0 1.36.09 2 .27 1.53-1.04 2.2-.82 2.2-.82.44 1.1.16 1.92.08 2.12.51.56.82 1.27.82 2.15 0 3.07-1.87 3.75-3.65 3.95.29.25.54.73.54 1.48 0 1.07-.01 1.93-.01 2.2 0 .21.15.46.55.38A8.013 8.013 0 0 0 16 8c0-4.42-3.58-8-8-8z"></path></svg></a>
            }
            @if let Origin::GitLab{..} = c.ver.origin() {
              <a class="gh-logo" href="@url"><svg width="32" height="32" fill="currentColor" viewBox="125 180 340 200"><title>GitLab</title><path d="M461.48 298.35l-17.78-54.63a7.72 7.72 0 0 0-.43-1.47l-35.67-109.8a14.18 14.18 0 0 0-13.54-9.67 13.94 13.94 0 0 0-13.38 9.75l-34 104.63H239.37l-34.05-104.63a13.94 13.94 0 0 0-13.32-9.75h-.08a14.22 14.22 0 0 0-13.5 9.76l-35.7 109.93c0 .1-.08.18-.11.28l-18.1 55.61a20.29 20.29 0 0 0 7.37 22.71L288.26 434.7a8 8 0 0 0 9.45-.05l156.41-113.58a20.28 20.28 0 0 0 7.36-22.72m-233.75-45.13l43.59 134.16-104.64-134.16m148.05 134.19l41.8-128.62 1.8-5.57h61.1L324.76 374.5m69.44-231.67l30.63 94.33h-61.31m-22.03 16l-30.37 93.46L293 402.28l-48.42-149.12m-52.73-110.33l30.69 94.33h-61.27m-19.98 70.97a4.31 4.31 0 0 1-1.56-4.83l13.44-41.3 98.57 126.37m192.98-80.24l-110.46 80.21.37-.48L432.83 262l13.44 41.28a4.31 4.31 0 0 1-1.55 4.84"/></svg></a>
            }
          }
          @repo.owner<span class=un>/</span><wbr>@for (last, part) in package.split('_').identify_last() {@part@if !last {<span class=un>_<wbr></span>}}
        } else {
          @for (last, part) in c.ver.short_name().split('_').identify_last() {@part@if !last {<span class=un>_<wbr></span>}}
        }
      }
      </span>

    </h2>
    @if let Some(desc) = c.ver.description() {
      @if !c.has_no_readme_or_lib() {
        <p class=desc>@c.render_markdown_str(desc)</p>
      }
    }
    <p class=byline>
      @if c.ver.is_yanked() {
        was
      }
      by
      @if let Some(Contributors {authors, owners, co_owned, contributors, period_after_authors, contributors_as_a_team}) = Some(c.all_contributors()) {
        @for (last, a) in authors.iter().identify_last() {
          @if let Some(url) = url.author(a) {
            <a href="@url" @if a.owner {class="owner" title="owner"} else {class="contributor" title="contributor"}
              property="author" typeof="Person"><span property="name">@a.name()</span></a>@if !last {,} else {@if period_after_authors {.}}
          } else {
            @a.name()@if !last {,} else {@if period_after_authors {.}}
          }
        }
        @if contributors > 1 {
          <span class=contributors>@if !contributors_as_a_team {and}
          @if let Some(repo) = c.ver.repository() {
            @if contributors_as_a_team {(}<a href="@repo.contributors_http_url()">@if contributors == 100 {over }@contributors contributors</a>@if contributors_as_a_team {)}@if !owners.is_empty() {.}
          } else {
            @contributors contributors@if contributors_as_a_team {)}@if !owners.is_empty() {.}
          }
          </span>
        }
        @if !owners.is_empty() {
          <span class=coowners>
          <span>@if co_owned {Co-owned} else {Owned}</span>
          by @for (last, a) in owners.iter().identify_last() {
            @if let Some(url) = url.author(a) {
              <a href="@url" property="author" typeof="Person"><span property="name">@a.name()</span></a>@if !last {,} else {.}
            } else {
              @a.name()@if !last {,} else {.}
            }
          }
          </span>
        }
      }
    </p>
    <nav><ul>
      @if !c.ver.is_yanked() {
        @if c.has_reviews {
          <li><a class="button" href="@url.reviews(c.ver.origin())">Reviews</a></li>
        }
        <li><a class="button" href="@url.install(c.ver.origin())">@if c.has_reviews {Installation} else {Install}</a></li>
        @if let Some(doc) = c.api_reference_url() {
          <li><a href="@doc">API reference</a></li>
        }
      }
      @if let Some((url, label)) = c.repository_link() {
        <li><a href="@url" @if c.homepage_link().is_none() {property="url"}>@label</a></li>
      }
      @if let Some((url, label)) = c.documentation_link() {
        <li><a href="@url">@label</a></li>
      }
      @if let Some((url, label)) = c.homepage_link() {
        <li><a href="@url" property="url" >@label</a></li>
      }
    </ul></nav>
    </div>
  </header>
  <main>
    <div class="inner-col">
      <section id="readme-deps">
        <div>
          <section class="about-crate">
            <section id="versions">
              @if let Some(parts) = c.version_stats_summary() {
                <h3>
                  @if let Some(url) = c.changelog_url() {
                    <a href="@url">@parts.0</a>
                  } else {
                    @parts.0
                  }
                  @if let Some(extra) = parts.1 {<span>@extra</span>}
                </h3>
              }
              @if c.ver.edition() == Edition::E2015 {
                <p class="edition-2018">Uses old Rust 2015</p>
              }
              <table>
                @for (i,gr) in c.top_versions().enumerate() {
                  <tr><th content="@gr.ver.num" property="@if i == 0 {softwareVersion}">
                    @if c.is_version_new(&gr.ver, i) {
                      <span class=new vocab="" property="">new</span>
                    }
                    @gr.ver.num
                  </th><td property="@if i == 0 {datePublished}" class="date">
                    @if gr.ver.yanked {
                      <del>@CratePage::format(&gr.ver.created_at)</del>
                    } else {
                      @CratePage::format(&gr.ver.created_at)
                    }
                  </td></tr>
                }
              </table>
            </section>

            <section id="downloads">
              @if let Some((top, cat)) = c.top_category() {
                <p class="top-n">#<b>@top</b> in <a href="@url.category(cat)" title="@cat.description">@cat.name</a></p>
              } else {
                @if let Some((top, keyword)) = c.top_keyword() {
                  <p class="top-n">#<b>@top</b> in <a href="@url.keyword(&keyword)">#@keyword</a></p>
                }
              }
              @if let Some(dl) = c.downloads_per_month() {
                @if dl > 50 {
                  @if let Some(g) = c.download_graph(182, 56) {
                    @:downloads(&g)
                  }
                }
              } else {
                @if let Some((stars, watchers)) = c.github_stargazers_and_watchers() {
                  <p><b>@c.format_number(stars)</b> star@if stars != 1 {s} & <b>@c.format_number(watchers)</b> watcher@if watchers != 1 {s}</p>
                }
              }
              <p>
                @if let Some(dl) = c.downloads_per_month() {
                  @if dl > 20 {
                    <b>@c.format_number(dl)</b> downloads per month
                  }
                }
                @if let Some(d) = c.dependents_stats() {
                  @if d.direct > 0 {
                  <br>
                    @if d.direct == 1 && (d.deps == 1 || d.former_glory < 0.8) {
                      @if let Some(name) = d.name {
                        Used in <a href="@url.crate_by_origin(&Origin::from_crates_io_name(name))">@name</a>
                      }
                    } else {
                      @if d.deps != d.direct && d.former_glory > 0.7 {
                          @if d.direct == 1 {
                            Used in <b>@c.format_number(d.deps)</b> crate@if d.deps != 1 {s}
                            @if let Some(name) = d.name {
                              (via <a href="@url.crate_by_origin(&Origin::from_crates_io_name(name))">@name</a>)
                            }
                          } else {
                            @if let Some(link) = url.reverse_deps(c.ver.origin()) {
                              Used in <a href="@link"><b>@c.format_number(d.deps)</b> crate@if d.deps != 1 {s}
                              (@c.format_number(d.direct)&nbsp;directly)</a>
                            }
                          }
                      } else {
                        @if let Some(link) = url.reverse_deps(c.ver.origin()) {
                          @if d.former_glory < 0.3 {
                            <a href="@link">This crate has lost popularity</a>
                          } else {
                            Used in <a href="@link">@if d.direct > 5 {less than} <b>@c.format_number(d.direct)</b>&nbsp;crate@if d.direct != 1 {s}</a>
                          }
                        }
                      }
                    }
                }}
              </p>
            </section>
            <section id="sloc">
              <section id="license">
                @if let Some(lic) = c.ver.license_name() {
                  <b property="license">@lic</b>
                  @if lic.len() < 8 && c.viral_license.is_none() {
                    license
                  }
                } else {
                  @if let Some(filename) = c.ver.license_file() {
                    <b title="@filename">Custom license</b>
                  }
                }
                @if let Some(ref vir) = c.viral_license {
                  and
                  @if vir.optional {
                    maybe
                  }
                  <a href="@url.crate_by_origin(&vir.origin)">@vir.license</a>
                  @if !vir.optional && vir.license.len() < 8 {
                    licenses
                  }
                }
              </section>

              @if let Some(sz) = &c.sizes {
                <p>
                  <span title="@(c.format_kbytes(sz.tarball)) as tarball">@if sz.tarball > 1000000 || sz.uncompressed > 10000000 {
                    <b>@c.format_kbytes(sz.tarball.max(sz.uncompressed))</b>
                  } else {
                    @c.format_kbytes(sz.tarball.max(sz.uncompressed))
                  }</span>
                  @if let Some((total, _)) = c.lang_stats {
                    @if total >= 50 {
                      <br>
                      @if total >= 1000 {
                        @if let Some((val, unit)) = Some(c.format_knumber(total)) {
                          <span title="@c.format_number(total)">
                            @if total > 20000 {
                              <b>@val@unit</b>
                            } else {
                              @val@unit
                            }
                          </span>
                          <abbr title="Lines of code, excluding comments">SLoC</abbr>
                        }
                      } else {
                        @total <span title="Lines of code, excluding comments">lines</span>
                      }
                    }
                  }
                </p>
                @if let Some((total, stats)) = &c.lang_stats {
                  @if let Some(sloc) = c.langs_chart(stats, 360) {
                    @if sloc.len() > 1 && *total > 1000 {
                      <svg viewBox="-1 -1 59 59" width="60" height="60">
                        @for (lang, lines, (x, w)) in sloc {
                          <path d="@CratePage::svg_path_for_slice(x,if x+w < 359 {w+1} else {w},360,58)" fill="@lang.color()"><title>@lang.name() @if let Some((val,unit)) = Some(c.format_knumber(lines.code as usize)) {@val@unit} SLoC @if lines.comments > 1 { // @c.format_fraction(lines.comments as f64 / (lines.code+lines.comments) as f64) comments }</title></path>
                        }
                      </svg>
                    }
                  }
                }
              }
            </section>
          </section>

          @if let Some(readme) = c.ver.readme() {
              <section id=readme class="readme" vocab="">
                @c.render_readme(readme)
              </section>
          } else {
            @if c.has_no_readme_or_lib() {
              <section id=readme class="readme" vocab="">
                @if let Some(desc) = c.ver.description() {
                  <hr>
                  <p class=desc>@c.render_markdown_str(desc)</p>
                } else {
                  <p class=error>(This crate has no description)</p>
                }
              </section>
            }
          }

          @if c.is_readme_short() {
            @if let Some(intro) = c.render_lib_intro() {
              <hr>
              <section id=lib_intro class="readme" vocab="">
                <h3>
                  @if let Some(doc) = c.api_reference_url() {
                    <a href="@doc"><code>lib.rs</code></a>:
                  } else {
                    <code>lib.rs</code>:
                  }
                </h3>
                @intro
              </section>
            }
          }
        </div>
        <section id="deps">
          @if let Some((normal, dev, build)) = c.direct_dependencies() {
            @if c.has_runtime_deps() || c.ver.links().is_some() {
              @if let Some(depsurl) = url.deps(&c.ver) {
                <h4><a href="@depsurl">Dependencies</a></h4>
              } else {
                <h4>Dependencies</h4>
              }
            } else {
              <h4>No runtime deps</h4>
              @if dev.is_empty() && build.is_empty() && normal.is_empty() && !c.ver.has_buildrs() {
                @if let Some(f) = c.non_dep_features() {
                  <h4>Features</h4>
                  <ul>
                    @for f in f {<li><span class="feature">@f</span></li>}
                  </ul>
                }
              }
            }
            @if let Some(sz) = &c.sizes {
              @if sz.typical.tarball > 1000000 || sz.typical.tarball > sz.tarball.div(2) {
                <p>
                  <span title="amortized size; approx. @c.format_kbytes(sz.typical.tarball) compressed">@if sz.typical.tarball > 8000000 || sz.typical.uncompressed > 50000000 {
                    ~<b>@c.format_kbytes_range(sz.minimal.uncompressed, sz.typical.tarball.max(sz.typical.uncompressed))</b>
                  } else {
                    ~@c.format_kbytes_range(sz.minimal.uncompressed, sz.typical.tarball.max(sz.typical.uncompressed))
                  }</span>
                  <br>
                  @if sz.typical.lines >= 10000 {
                    @if let Some((val, unit)) = Some(c.format_knumber(sz.typical.lines)) {
                      <span title="estimated">~@val@unit</span> <abbr title="approx. additional lines of code">SLoC</abbr>
                    }
                  }
                </p>
              }
            }
            <nav aria-label="Dependencies">
            <ul class="@if normal.len() > 4 {long}">
              @:deps_list(c, url, &normal, None)
              @if let Some(links) = c.ver.links() {
                <li><span class="label label-build">links</span> <code>@links</code></li>
              }
            </ul>
            <ul class="dev @if dev.len() > 4 {long}">
              @if c.ver.has_buildrs() {
                <li><span class="label label-build">build</span> <code>build.rs</code></li>
              }
              @:deps_list(c, url, &build, Some("build"))
              @:deps_list(c, url, &dev, Some("dev"))
              @if !dev.is_empty() || !build.is_empty() || !normal.is_empty() || c.ver.has_buildrs() {
                @if let Some(f) = c.non_dep_features() {
                  <li>
                    other feature@if f.len() != 1 {s}:
                    @for f in f.iter().take(100) {
                      <span class="feature">@f</span>
                    }
                    @if f.len() > 100 {
                      <details><summary>and more…</summary>
                        @for f in f.iter().skip(100) {
                          <span class="feature">@f</span>
                        }
                      </details>
                    }
                  </li>
                }
              }
            </ul>
            </nav>
          } else {
            <p class="error">Dependencies unknown</p>
          }
        </section>
      </section>
    </div>
  </main>
  </div>

  <footer>

    <div class="inner-col">
      @if let Some(crates) = c.related_crates() {
        @if !crates.is_empty() {
          <nav class=seealso aria-label="See also">
            See also:
            @for (last, cra) in crates.into_iter().identify_last() {
              <a href="@url.crate_by_origin(&cra)">@cra.short_crate_name()</a>@if !last {,}
            }
          </nav>
        }
      }
      <aside role="contentinfo"><p><a href="/"><b>Lib.rs</b></a> is an unofficial list of Rust/Cargo crates. It's <a href="https://gitlab.com/crates.rs?sort=stars_desc">open-source</a>, created by <a href="https://github.com/kornelski">kornelski</a>. If something is missing or incorrect with the site, please <a href="https://gitlab.com/crates.rs/crates.rs/issues/new">file a bug</a>. <nobr>This page was generated on @date_now().</nobr></p></aside>
    </div>
  </footer>
})
